#!/usr/bin/perl -w
# vim:set syntax=off:
  use bytes;
  use POSIX;
  use IO::Socket;
  use Socket;

  $group = "alt.binaries.sounds.mp3.classical";
  
  $port = 119;     
  $server = IO::Socket::INET->new(LocalPort => $port,
                                  Listen    => 2,
				  ReuseAddr => 1) 
    or die "Can't make server socket: $@\n";
  
  # begin with empty buffer
  
  # file MUST be sorted numerically

  open (IN,"<$group") || die "cannot open $group";
  print "slurping  ... \n";
  undef $low;
  while(<IN>) {
     $line=$_;
     next if (/^\./);
     ($artno) = split(/\t/);
     $low = $artno unless (defined $low);
     $xover{$artno} = $line;
  }
  close(IN);
  $high = $artno;
  print "         ... done, low $low high $high\n";

  while (1) {
      my $client;
      my $inbuffer  = "";
      $client = $server->accept( ); 
      $retval = $client->send("200 News.GigaNews.Com\r\n",0);
      print "send: retval $retval\n";
      while (1) {
        $client->recv($inbuffer, POSIX::BUFSIZ, 0);
        $nbytes = length($inbuffer);
        last if ($nbytes == 0); # EOF 
        print "REQ: $inbuffer\n";
	if ($inbuffer =~ /^AUTHINFO USER/i) {
	    $client->send("381 more authentication required\r\n",0);
	    next;
	}
	if ($inbuffer =~ /^AUTHINFO PASS/i) {
	    $client->send("281 News.GigaNews.Com\r\n",0);
	    next;
	}
	if ($inbuffer =~ /^MODE READER/i) {
	    $client->send("200 News.GigaNews.Com\r\n",0);
	    next;
	}
        if ($inbuffer =~ /^LIST NEWSGROUPS/i) {
	    $client->send("501 no such list available\r\n",0);
            next;
	}
        if ($inbuffer =~ /^LIST/i) {
	    $client->send("215 newsgroups follow\r\n",0);
	    $client->send("alt.binaries.sounds.mp3.classical $low $high y\r\n.\r\n");
            next;
	}
	if ($inbuffer =~ /^GROUP/i) {
            chomp($inbuffer); $inbuffer =~ s/\s*$//g;
            my $dummy;
            ($dummy, $grp) = split(/\s/,$inbuffer);
            my $n = $high - $low + 1;
	    $client->send("211 $n $low $high $grp\r\n",0);
	    next;
	}
	if ($inbuffer =~ /^XOVER/i) {
	    $inbuffer =~ /(\d+)-(\d+)/;
            $xlow = $1; $xhigh = $2;
            print "xover low: $xlow  high: $xhigh\n";
	    $client->send("224 xover information follows\r\n",0);
	} else { 
	    die "unsupported cmd: $inbuffer";
	}
        for ($i=$xlow; $i <=$xhigh; ++$i) {
                if (exists $xover{$i}) 
                     { $ret = $client->send($xover{$i},0); }
	}
    	$ret = $client->send(".\r\n",0);	
      }
      print "closing socket\n";
      close($client);
  }

